#include <bits/stdc++.h>
#define ll long long

using namespace std;

int main()
{
    cin.tie(0);cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n,k;
    cin >> n >> k;
    char a[n];
    for(int i = 0; i < n;i++)
    {
        cin >> a[i];
    }
    int c[k] = {0};
    for(int i = 0; i < n;i++)
    {
        int h = INT_MAX;
        c[int(a[i])-97]++;
        for(int j = 0; j < k;j++)
        {
            if(h > c[j]) h = c[j];
        }
        cout << h+1 << " ";
    }
}